
var lastTime = 0, delta = 0, frameCounter = 0, frameTimer = 0, frameMultiplier = 1, lastFrameRate = 1,
fbuf = new Float32Array(16), pumpkinMapImg = new Image(), lastUnloadSave = 0,

DEFAULT_CONFIG = {"main":{"backgrounds":1,"floors":0,"tool_size":0.0181761143410853,"tool_depth":1},"bg":{"bg_color":{"r":255,"g":255,"b":255},"bg_exposure":1,"light_color":{"r":255,"g":255,"b":255},"light_strength":1,"light_size":0.02,"camera_fov":1.2},"floor":{"floor_color":{"r":255,"g":255,"b":255},"floor_scale":0.5,"floor_height":0.2},"pumpkin":{"pumpkin_color":{"r":235,"g":155,"b":49},"pumpkin_height":1,"pumpkin_indent":0.5,"pumpkin_rate0":10,"pumpkin_size0":0.01,"pumpkin_rate1":10,"pumpkin_size1":0.005,"pumpkin_rate2":18,"pumpkin_size2":0.005,"pumpkin_rate3":33,"pumpkin_size3":0.003}};


//DOM loaded, program entry point
document.addEventListener("DOMContentLoaded",function() {
	//initialize systems
	if (!InitializeRendering()) return;
	InitializeUI();
	InitializePumpkinCarving();
	
	//load saved state
	IndexedStorage_Open("PumpkinCarvingSimulator",function() {
		if (indexedStorageDBName) {
			IndexedStorage_Load("s",OnLoadIDBSave);
		}
	});
	
	//auto save
	window.addEventListener("beforeunload",function(e) {//use before unload to give indexedstorage time to commit changes, stupid async only api combined with synchronous events
		IndexedStorage_Store("s",JSON.stringify(SaveState()));
		var ltime = lastUnloadSave;
		lastUnloadSave = lastTime;
		if (lastTime-ltime > 20000) {
			return e.returnValue = "Are you sure? You have unsaved changes.";
		}
	});
	
	//apply initial settings
	ChangeGUI(gui);
	ChangeGUI(floorcfg);
	ChangeGUI(bgcfg);
	ChangeGUI(pumpkincfg);
	
	lastTime = Date.now();
	MainLoop();
});

//display fullscreen crash message
function FatalCrash(msg) {
	document.body.innerHTML = "<span class='fatalcrash'>"+msg+"</span>";
}

function OnLoadIDBSave(id, dat) {
	if (dat) {
		LoadState(JSON.parse(dat));
	}
}


//get JSON object representing save state
function SaveState() {
	var ss = {};
	ss["main"] = gui.GetValues();
	ss["bg"] = bgcfg.GetValues();
	ss["floor"] = floorcfg.GetValues();
	ss["pumpkin"] = pumpkincfg.GetValues();
	
	ss["map"] = GetPumpkinMapData();
	
	return ss;
}
//load state from JSON object
function LoadState(ss) {
	pumpkinMapImg.src = ss["map"];

	gui.SetValues(ss["main"]);
	bgcfg.SetValues(ss["bg"]);
	floorcfg.SetValues(ss["floor"]);
	pumpkincfg.SetValues(ss["pumpkin"]);
	
	ChangeGUI(gui);
	ChangeGUI(bgcfg);
	ChangeGUI(floorcfg);
	ChangeGUI(pumpkincfg);
}
pumpkinMapImg.onload = function() {
	if (pumpkinMapImg.width == 1024 && pumpkinMapImg.height == 512) {
		gl.bindTexture(gl.TEXTURE_2D,pumpkinHeightA.texture);
		gl.texImage2D(gl.TEXTURE_2D,0,gl.RGBA,gl.RGBA,gl.UNSIGNED_BYTE,pumpkinMapImg);
	} else {
		TEV(errorPanel);
	}
};

//returns base64 data url of pumpkin map image
function GetPumpkinMapData() {
	quickGLCanvas.width = display.width = 1024;
	quickGLCanvas.height = display.height = 512;
	display.Bind();
	copyShader.Use();
	BindTexture(copyShader["buffer"], pumpkinHeightA.texture);
	gl.drawArrays(gl.TRIANGLES,0,3);
	UnbindAllTextures();
	var mdat = quickGLCanvas.toDataURL();
	OnWindowResize();
	return mdat;
}


//main rendering and update loop
function MainLoop() {
	//current time and compute delta
	var nowTime = Date.now();
	delta = (nowTime-lastTime)/1000;
	
	if (capturingRender) {
		//render multiple frames per requestAnimationFrame during rendering
		for (var i = 0; i < frameMultiplier && capturingRender; i++) Render();
		
		frameCounter += frameMultiplier;
		frameTimer += delta;
		if (frameTimer >= 1) {
			var fps = frameCounter/frameTimer;
			if (fps >= lastFrameRate) frameMultiplier++;
			else if (fps < lastFrameRate*0.75) frameMultiplier = Math.max(1,frameMultiplier-1);
			lastFrameRate = fps;
			frameTimer = frameCounter = 0;
		}
	} else {
		if (!document.hidden) {//only render/update when document visible
			Update();
			Render();
		}
	}
	
	//next frame
	lastTime = nowTime;
	requestAnimationFrame(MainLoop);
}

