
var uiPanel, bgPanel, floorPanel, pumpkinPanel, renderPanel, renderingPanel, resultPanel, creditsPanel, guidePanel, confirmPanel, errorPanel,
freeCamBtn, renderState,
gui, bgcfg, floorcfg, pumpkincfg, rendercfg,
customBackgroundImage, lastCustomBackgroundURL = null,
customFloorColor, customFloorColorURL = null, customFloorHeight, customFloorHeightURL = null, customFloorRough, customFloorRoughURL = null,
toolButtonElements = new Array(4),
lastSaveURL = null, lastMapURL = null, confirming = 0,
CONFIRM_NEW = 0, CONFIRM_LOAD = 1, CONFIRM_IMPORT = 2,
PUMPKIN_COLORS;


function InitializeUI() {
	PUMPKIN_COLORS = [new InputGUIColor(226,130,50), new InputGUIColor(225,108,42), new InputGUIColor(241,179,42), new InputGUIColor(241,186,110)];

	uiPanel = document.getElementById("uipanel");
	bgPanel = document.getElementById("bgpanel");
	floorPanel = document.getElementById("floorpanel");
	pumpkinPanel = document.getElementById("pumpkinpanel");
	renderPanel = document.getElementById("renderpanel");
	renderingPanel = document.getElementById("renderingpanel");
	resultPanel = document.getElementById("resultpanel");
	creditsPanel = document.getElementById("creditspanel");
	guidePanel = document.getElementById("guidepanel");
	confirmPanel = document.getElementById("confirmpanel");
	errorPanel = document.getElementById("errorpanel");
	
	customBackgroundImage = document.getElementById("custom_bg_img");
	customFloorColor = document.getElementById("custom_floor_color");
	customFloorHeight = document.getElementById("custom_floor_height");
	customFloorRough = document.getElementById("custom_floor_rough");
	renderState = document.getElementById("rendering_state");
	
	//init select elements
	SetSelectOptions("backgrounds",BACKGROUNDS,1);
	SetSelectOptions("floors",FLOORS,0);
	
	gui = new InputGUI(["backgrounds","floors","tool_size","tool_depth"]);
	bgcfg = new InputGUI(["bg_color","bg_exposure","light_color","light_strength","light_size","camera_fov"]);
	floorcfg = new InputGUI(["floor_color","floor_scale","floor_height"]);
	pumpkincfg = new InputGUI(["pumpkin_color","pumpkin_height","pumpkin_indent","pumpkin_rate0","pumpkin_size0","pumpkin_rate1","pumpkin_size1","pumpkin_rate2","pumpkin_size2","pumpkin_rate3","pumpkin_size3"]);
	rendercfg = new InputGUI(["render_width","render_height","render_samples","render_trans"]);
	
	//select tool
	toolButtonElements[0] = document.getElementById("tool_carve");
	toolButtonElements[1] = document.getElementById("tool_scoop");
	toolButtonElements[2] = document.getElementById("tool_fill");
	toolButtonElements[3] = document.getElementById("tool_clear");
	BEC("tool_carve",function() {
		toolButtonElements[currentTool].className = "btn";
		currentTool = TOOL_CARVE;
		toolButtonElements[currentTool].className = "btn btn_sel";
		if (flooding) StopFlooding();
	});
	BEC("tool_scoop",function() {
		toolButtonElements[currentTool].className = "btn";
		currentTool = TOOL_SCOOP;
		toolButtonElements[currentTool].className = "btn btn_sel";
		if (flooding) StopFlooding();
	});
	BEC("tool_fill",function() {
		toolButtonElements[currentTool].className = "btn";
		currentTool = TOOL_FILL;
		toolButtonElements[currentTool].className = "btn btn_sel";
	});
	BEC("tool_clear",function() {
		toolButtonElements[currentTool].className = "btn";
		currentTool = TOOL_CLEAR;
		toolButtonElements[currentTool].className = "btn btn_sel";
	});
	toolButtonElements[0].click();
	
	//new/save/load
	BEC("new",function() {
		confirming = CONFIRM_NEW;
		TEV(confirmPanel);
	});
	BEC("save",function() {
		if (lastSaveURL) URL.revokeObjectURL(lastSaveURL);
		lastSaveURL = URL.createObjectURL(new Blob([JSON.stringify(SaveState())]));
		SaveFilePrompt(lastSaveURL,"Pumpkin.json");
	});
	BEC("load",function() {
		confirming = CONFIRM_LOAD;
		TEV(confirmPanel);
	});
	BEC("confirm_yes",function() {
		switch (confirming) {
			case CONFIRM_NEW:
				//clear default pumpkin mask
				pumpkinHeightA.Bind();
				gl.clearColor(1,0,0,1);
				gl.clear(gl.COLOR_BUFFER_BIT);
		
				//load default state
				LoadState(DEFAULT_CONFIG);
				break;
				
			case CONFIRM_LOAD:
				//load
				LoadFilePrompt(OnLoadStateFile,".json",false);
				break;
			
			case CONFIRM_IMPORT:
				LoadFilePrompt(OnLoadPumpkinMap,"image/*",false);
				break;
		}
		TEV(confirmPanel);
	});
	BEC("confirm_no",function() {
		TEV(confirmPanel);
	});
	
	//select background/floor/pumpkin
	gui["backgrounds"].onChange = function(obj) {
		SetBackground(obj.value);
	};
	gui["floors"].onChange = function(obj) {
		SetFloor(obj.value);
	};
	BEC("pumpkin_rand",function() {
		var pe = pumpkincfg.elements;
		for (var i = 0; i < pe.length; i++) {
			var ele = pe[i];
			if (ele.type === INPUTGUITYPE_RANGE) {
				var v = Math.random(), vmin = parseFloat(ele.element.min), vmax = parseFloat(ele.element.max);
				if (ele.element.step === "any") v = vmin+(vmax-vmin)*v;
				else {
					var st = parseFloat(ele.element.step);
					v = vmin+Math.floor((vmax-vmin)*v/st)*st;
				}
				ele.SetValue(v);
			
			} else if (ele.type === INPUTGUITYPE_COLOR) {
				var r0 = Math.random(), i0 = 1-r0,
					r1 = Math.random(), i1 = 1-r1,
					r2 = Math.random(), i2 = 1-r2,
					r3 = 0.5+Math.random()*0.5,
					c = PUMPKIN_COLORS;
				ele.SetValue(new InputGUIColor(Math.round((c[0].r*i0+c[1].r*r0)*i2 + (c[2].r*i1+c[3].r*r1)*r2),
					Math.round((c[0].g*i0+c[1].g*r0)*i2 + (c[2].g*i1+c[3].g*r1)*r2),
					Math.round((c[0].b*i0+c[1].b*r0)*i2 + (c[2].b*i1+c[3].b*r1)*r2)));
			}
			if (ele.onChange) ele.onChange(ele);
		}
	});
	
	//configure background/floor/pumpkin toggle
	BEC("background_cfg",function() {
		if (TEV(bgPanel)) {
			floorPanel.style.display = "none";
			pumpkinPanel.style.display = "none";
		}
	});
	BEC("floor_cfg",function() {
		if (TEV(floorPanel)) {
			bgPanel.style.display = "none";
			pumpkinPanel.style.display = "none";
		}
	});
	BEC("pumpkin_cfg",function() {
		if (TEV(pumpkinPanel)) {
			bgPanel.style.display = "none";
			floorPanel.style.display = "none";
		}
	});
	
	//background configure
	bgcfg["bg_color"].onChange = function(obj) {
		UpdateBackgroundParams();
	};
	bgcfg["bg_exposure"].onChange = function(obj) {
		UpdateBackgroundParams();
	};
	bgcfg["light_color"].onChange = function(obj) {
		ComputeLightColor();
		ClearPathTracer();
	};
	bgcfg["light_strength"].onChange = function(obj) {
		ComputeLightColor();
		ClearPathTracer();
	};
	bgcfg["light_size"].onChange = function(obj) {
		frameParams[39] = obj.value;
		ClearPathTracer();
	};
	bgcfg["camera_fov"].onChange = function(obj) {
		cameraFov = obj.value;
		OnWindowResize();
		ClearPathTracer();
	};
	BEC("bg_load_custom",function() {
		LoadFilePrompt(OnLoadCustomBackground,"image/*",false);
	});
	
	//floor configure
	floorcfg["floor_color"].onChange = function(obj) {
		frameParams[32] = Math.pow(obj.value.r/255,2.2);
		frameParams[33] = Math.pow(obj.value.g/255,2.2);
		frameParams[34] = Math.pow(obj.value.b/255,2.2);
		ClearPathTracer();
	};
	floorcfg["floor_height"].onChange = function(obj) {
		frameParams[14] = obj.value;
		ComputeFloorOffset();
		ClearPathTracer();
	};
	floorcfg["floor_scale"].onChange = function(obj) {
		frameParams[15] = Math.pow(obj.value,3)*2;
		ClearPathTracer();
	};
	BEC("floor_load_color",function() {
		LoadFilePrompt(OnLoadCustomFloorColor,"image/*",false);
	});
	BEC("floor_load_height",function() {
		LoadFilePrompt(OnLoadCustomFloorHeight,"image/*",false);
	});
	BEC("floor_load_rough",function() {
		LoadFilePrompt(OnLoadCustomFloorRough,"image/*",false);
	});
	
	
	//pumpkin configure
	pumpkincfg["pumpkin_color"].onChange = function(obj) {
		frameParams[28] = Math.pow(obj.value.r/255,2.2);
		frameParams[29] = Math.pow(obj.value.g/255,2.2);
		frameParams[30] = Math.pow(obj.value.b/255,2.2);
		ClearPathTracer();
	};
	pumpkincfg["pumpkin_height"].onChange = function(obj) {
		frameParams[7] = 1/obj.value;
		ComputeFloorOffset();
		ComputePumpkinBounds();
		ClearPathTracer();
	};
	pumpkincfg["pumpkin_indent"].onChange = function(obj) {
		frameParams[19] = obj.value;
		ComputeFloorOffset();
		ComputePumpkinBounds();
		ClearPathTracer();
	};
	pumpkincfg["pumpkin_rate0"].onChange = function(obj) {
		frameParams[20] = obj.value/(Math.PI*2);
		ClearPathTracer();
	};
	pumpkincfg["pumpkin_size0"].onChange = function(obj) {
		frameParams[21] = obj.value;
		ClearPathTracer();
	};
	pumpkincfg["pumpkin_rate1"].onChange = function(obj) {
		frameParams[22] = obj.value;
		ClearPathTracer();
	};
	pumpkincfg["pumpkin_size1"].onChange = function(obj) {
		frameParams[23] = obj.value;
		ClearPathTracer();
	};
	pumpkincfg["pumpkin_rate2"].onChange = function(obj) {
		frameParams[24] = obj.value;
		ClearPathTracer();
	};
	pumpkincfg["pumpkin_size2"].onChange = function(obj) {
		frameParams[25] = obj.value;
		ClearPathTracer();
	};
	pumpkincfg["pumpkin_rate3"].onChange = function(obj) {
		frameParams[26] = obj.value;
		ClearPathTracer();
	};
	pumpkincfg["pumpkin_size3"].onChange = function(obj) {
		frameParams[27] = obj.value;
		ClearPathTracer();
	}
	BEC("pumpkin_import",function() {
		confirming = CONFIRM_IMPORT;
		TEV(confirmPanel);
	});
	BEC("pumpkin_export",function() {
		SaveFilePrompt(GetPumpkinMapData(),"PumpkinMap.png");
	});
	
	//toggle free camera
	freeCamBtn = document.getElementById("free_camera");
	freeCamBtn.addEventListener("click",function() {
		cameraRot.Set(0,0,0);
		cameraX = 0; cameraY = 0; cameraZ = -3;
		cameraLength = 3;
		freeCamera = !freeCamera;
		freeCamBtn.className = freeCamera?"btn btn_sel":"btn";
		
		UpdateCamera();
		ClearPathTracer();
	});
	
	//rendering
	BEC("render",function() {
		TEV(renderPanel);
	});
	BEC("begin_render",function() {
		TEV(renderPanel);
		TEV(renderingPanel);

		//apply to render textures
		var width = rendercfg["render_width"].value, height = rendercfg["render_height"].value;
		rtA.SetSize(width,height,gl.RGBA,gl.RGBA,gl.FLOAT);
		rtB.SetSize(width,height,gl.RGBA,gl.RGBA,gl.FLOAT);
		frameParams[0] = cameraFov*rtA.aspectX;
		frameParams[1] = cameraFov*rtA.aspectY;
		frameParams[3] = 4/(width+height);

		frameParams[2] = 0;//clear path tracer
		frameTimer = frameCounter = 0;
		frameMultiplier = lastFrameRate = 1;
		renderSamples = 0;
		renderNumSamples = rendercfg["render_samples"].value;
		capturingRender = true;
		
	});
	BEC("cancel_render",function() {
		TEV(renderPanel);
	});
	BEC("cancel_rendering",function() {
		capturingRender = false;
		OnWindowResize();
		TEV(renderingPanel);
	});
	BEC("close_result",function() {
		TEV(resultPanel);
	});
	
	//view help/controls
	BEC("view_controls",function() {
		TEV(guidePanel);
	});
	BEC("close_controls",function() {
		TEV(guidePanel);
	});
	
	//view credits
	BEC("view_credits",function() {
		TEV(creditsPanel);
	});
	BEC("close_credits",function() {
		TEV(creditsPanel);
	});
	
	BEC("error_close",function() {
		TEV(errorPanel);
	});
	
	//toggle touch controls UI if detected
	var touchDevice = "ontouchstart" in window;
	document.getElementById("mousecontrols").style.display = touchDevice?"none":"block";
	document.getElementById("touchcontrols").style.display = touchDevice?"block":"none";
}


//shortcut for getting element by id and adding click event listener
function BEC(id,cb) {
	document.getElementById(id).addEventListener("click",cb);
}

//shortcut for toggling visibility of element, returns true if now visible
function TEV(ele) {
	var vis = ele.style.display=="none";
	ele.style.display = vis?"block":"none";
	return vis;
}

//save file containing data in dataUrl, must be called from event
function SaveFilePrompt(dataUrl,fname) {
	var a = document.createElement("a");
	a.href = dataUrl;
	a.download = fname;
	a.click();
}
//load file prompt hooked to callback, must be called from event like onclick
function LoadFilePrompt(callback,acceptType,multiple) {
	var fi = document.createElement("input");
	fi.type = "file";
	if (acceptType) fi.accept = acceptType;
	if (multiple) fi.multiple = true;
	fi.addEventListener("change",callback);
	fi.click();
}


//initialize select element options
function SetSelectOptions(id,opt,defaultInd) {
	var ele = document.getElementById(id);
	for (var i = 0; i < opt.length; i++) {
		var oe = document.createElement("option");
		oe.textContent = opt[i];
		ele.appendChild(oe);
	}
	ele.selectedIndex = defaultInd?defaultInd:0;
}


//load custom image files
function OnLoadCustomBackground(e) {
	var fs = e.target.files;
	if (fs && fs.length) {
		var newUrl = URL.createObjectURL(fs[0]);
		background.image.src = newUrl;
		customBackgroundImage.src = newUrl;
		if (lastCustomBackgroundURL) URL.revokeObjectURL(lastCustomBackgroundURL);
		lastCustomBackgroundURL = newUrl;
	}
}
function OnLoadCustomFloorColor(e) {
	var fs = e.target.files;
	if (fs && fs.length) {
		var newUrl = URL.createObjectURL(fs[0]);
		floorCol.image.src = newUrl;
		customFloorColor.src = newUrl;
		if (customFloorColorURL) URL.revokeObjectURL(customFloorColorURL);
		customFloorColorURL = newUrl;
	}
}
function OnLoadCustomFloorHeight(e) {
	var fs = e.target.files;
	if (fs && fs.length) {
		var newUrl = URL.createObjectURL(fs[0]);
		floorHeight.image.src = newUrl;
		customFloorHeight.src = newUrl;
		if (customFloorHeightURL) URL.revokeObjectURL(customFloorHeightURL);
		customFloorHeightURL = newUrl;
	}
}
function OnLoadCustomFloorRough(e) {
	var fs = e.target.files;
	if (fs && fs.length) {
		var newUrl = URL.createObjectURL(fs[0]);
		floorRough.image.src = newUrl;
		customFloorRough.src = newUrl;
		if (customFloorRoughURL) URL.revokeObjectURL(customFloorRoughURL);
		customFloorRoughURL = newUrl;
	}
}

function OnLoadStateFile(e) {
	var fs = e.target.files;
	if (fs && fs.length) {
		var fr = new FileReader();
		fr.onload = OnLoadStateText;
		fr.readAsText(fs[0]);
	}
}
function OnLoadStateText(e) {
	LoadState(JSON.parse(e.target.result));
}

function OnLoadPumpkinMap(e) {
	var fs = e.target.files;
	if (fs && fs.length) {
		var nurl = URL.createObjectURL(fs[0]);
		pumpkinMapImg.src = nurl;
		if (lastMapURL) URL.revokeObjectURL(lastMapURL);
		lastMapURL = nurl;
	}
}


//call onChange events in gui
function ChangeGUI(gui) {
	var eles = gui.elements;
	for (var i = 0; i < eles.length; i++) {
		var ele = eles[i];
		if (ele.onChange) ele.onChange(ele);
	}
}


//template allows finding elements by id after id has been removed, allows deep cloning while still addressing elements by id
/**@constructor*/
function GUITemplate(id,ele) {
	this.rootElement = ele?ele:document.getElementById(id);
	this.rootElement.style.display = "none";
	this.cloneNodesIds = [];
	this.Build(this.rootElement);
	delete this.cloneNodesIds;
}
//recursively traverse element nodes to build template
GUITemplate.prototype.Build = function(ele) {
	if (ele.id && ele.id.length) {
		this[ele.id] = this.cloneNodesIds.slice();
		ele.removeAttribute("id");
	}

	var cn = ele.childNodes, cid = this.cloneNodesIds.length;
	this.cloneNodesIds.push(0);
	for (var i = 0; i < cn.length; i++) {
		this.cloneNodesIds[cid] = i;
		this.Build(cn[i]);
	}
	this.cloneNodesIds.length--;
}
//clone root element of template
GUITemplate.prototype.Clone = function() {
	var ele = this.rootElement.cloneNode(true);
	ele.style.removeProperty("display");
	return ele;
}
//get element from template id array, example: this.Get(rootEle, this["background"]) 
GUITemplate.prototype.Get = function(root,cid) {
	var cn = root.childNodes;
	for (var i = 0; i < cid.length; i++) root = root.childNodes[cid[i]];
	return root;
}
//setup InputGUI for elements in root
GUITemplate.prototype.CreateInputGUI = function(root,ids) {
	var eles = new Array(ids.length);
	for (var i = 0; i < ids.length; i++) eles[i] = this.Get(root,this[ids[i]]);
	return new InputGUI(ids,eles);
}
//setup click events for elements in root example: (rootElement,{"elementId":callbackFunction},obj[optional])
GUITemplate.prototype.AddClickEvents = function(root,evts,attachObj) {
	for (var k in evts) {
		var ele = this.Get(root,this[k]);
		ele.addEventListener("click",evts[k]);
		if (attachObj) ele.attachedObject = attachObj;
	}
}



var INPUTGUITYPE_CHECKBOX = 0, INPUTGUITYPE_TEXT = 1, INPUTGUITYPE_NUMBER = 2, INPUTGUITYPE_RANGE = 3, INPUTGUITYPE_COLOR = 4, INPUTGUITYPE_SELECT = 5;
/**@constructor*/
function InputGUIElement(i,ele,gui) {
	this.id = i;
	this.element = ele;
	this.inputGUI = gui;
	var tpid = INPUTGUITYPE_SELECT;
	if (ele.type === "checkbox") tpid = INPUTGUITYPE_CHECKBOX;
	else if (ele.type === "text") tpid = INPUTGUITYPE_TEXT;
	else if (ele.type === "number") tpid = INPUTGUITYPE_NUMBER;
	else if (ele.type === "range") tpid = INPUTGUITYPE_RANGE;
	else if (ele.type === "color") tpid = INPUTGUITYPE_COLOR;
	else if (ele.tagName === "TEXTAREA") tpid = INPUTGUITYPE_TEXT;
	this.type = tpid;
	this.value = ele.type==="color"?new InputGUIColor():null;
	this.onChange = null;
	this.changed = false;
}
InputGUIElement.prototype.SetValue = function(v) {
	if (this.type === INPUTGUITYPE_COLOR) {
		Object.assign(this.value,v);
		this.element.value = this.value.ToString();
	} else if (this.type === INPUTGUITYPE_SELECT) {
		this.value = v;
		this.element.selectedIndex = v;
	} else if (this.type === INPUTGUITYPE_CHECKBOX) {
		this.value = v;
		this.element.checked = v;
	} else {
		this.element.value = this.value = v;
	}
}

/**@constructor*/
function InputGUIColor(r,g,b) {
	this["r"] = r?r:0;
	this["g"] = g?g:0;
	this["b"] = b?b:0;
}
//parse color hex string
InputGUIColor.prototype.ParseString = function(str) {
	this.r = parseInt(str.substring(1,3),16);
	this.g = parseInt(str.substring(3,5),16);
	this.b = parseInt(str.substring(5,7),16);
}
//to color hex string
InputGUIColor.prototype.ToString = function() {
	var str = "#", t = this.r.toString(16);
	str += t.length===1?"0"+t:t;
	t = this.g.toString(16);
	str += t.length===1?"0"+t:t;
	t = this.b.toString(16);
	return str+(t.length===1?"0"+t:t);
}


//automatically parses states for input text, checkbox, number, range, color and select elements
/**@constructor*/
function InputGUI(ids,eles) {
	this.elements = new Array(ids.length);
	this.elementsChanged = false;
	
	for (var i = 0; i < ids.length; i++) {
		var ele = eles?eles[i]:document.getElementById(ids[i]),
			obj = new InputGUIElement(i,ele,this);
		this.elements[i] = obj;
		this[ids[i]] = obj;
		ele.inputGUIElement = obj;
		ele.addEventListener("input",InputGUI_OnChange);
		InputGUI_OnChange({target:ele});
	}
}
function InputGUI_OnChange(e) {
	var ele = e.target, obj = ele.inputGUIElement, ov = obj.value;
	switch (obj.type) {
		case INPUTGUITYPE_CHECKBOX:
			obj.value = ele.checked;
			break;
		
		case INPUTGUITYPE_TEXT:
			obj.value = ele.value;
			break;
			
		case INPUTGUITYPE_NUMBER:
			var minv = ele.min?ele.min:-Number.MAX_VALUE, maxv = ele.max?ele.max:Number.MAX_VALUE,
				pval = (ele.step&&ele.step==1)?parseInt(ele.value):parseFloat(ele.value);
			ele.value = obj.value = Math.max(minv,Math.min(maxv,isNaN(pval)||!isFinite(pval)?0:pval));
			break;
			
		case INPUTGUITYPE_RANGE:
			obj.value = parseFloat(ele.value);
			break;
			
		case INPUTGUITYPE_COLOR:
			obj.value.ParseString(ele.value);
			break;
		
		case INPUTGUITYPE_SELECT:
			obj.value = parseInt(ele.selectedIndex);
			break;
	}
	if (ov !== obj.value || obj.type === INPUTGUITYPE_COLOR) {
		obj.changed = obj.inputGUI.elementsChanged = true;
		if (obj.onChange) obj.onChange(obj);
	}
}

//get/set values from json object
InputGUI.prototype.GetValues = function() {
	var vals = {}, tele = this.elements;
	for (var i = 0; i < tele.length; i++) vals[tele[i].element.id] = this.elements[i].value;
	return vals;
}
InputGUI.prototype.SetValues = function(vals) {
	for (var k in vals) {
		var obj = this[k];
		if (obj) obj.SetValue(vals[k]);
	}
}
